%{
/*
	A simple lexical analyzer for English sentence.
*/
#include "yytab.h"	/* in Unix/Linux -- y.tab.h */
%}
%%

[\t ]+		/* ignore white spaces: tabs or blanks */;
is |
am |
are |
were |
was |
be |
being |
been		{ printf(" %s(be-verb)", yytext); return VERB; }

go |
goes |
went |
do |
study		{ printf(" %s(verb)", yytext); return VERB; }

good |
bad |
rich |
poor |
pretty |
beautiful	{ printf(" %s(adj)", yytext); return ADJ; }

very |
much |
too		{ printf(" %s(adj)", yytext); return ADV; }

to |
by |
in |
on |
at		{ printf(" %s(prep)", yytext); return PREP; }

the |
a		{ printf(" %s(det)", yytext); return DET; }

he |
she |
I |
you |
they		{ printf(" %s(pronoun)", yytext); return PRON; }

boy |
girl |
man |
men |
woman |
women |
student |
teacher |
school |
lunch		{ printf(" %s(noun)", yytext); return NOUN; }

[a-zA-Z]+	{ printf(" %s(undefined)", yytext); return 0; }

.
\n		{ ECHO;	/* default */ }
%%
/* empty */
